Index: libcfa/src/bitmanip.hfa
===================================================================
--- libcfa/src/bitmanip.hfa	(revision da36d25fb1a2f474bae010c7465231546031fa03)
+++ libcfa/src/bitmanip.hfa	(revision 21923bd69beadddd764dbbb5886c599246dec848)
@@ -11,6 +11,6 @@
 // Created On       : Sat Mar 14 18:12:27 2020
 // Last Modified By : Peter A. Buhr
-// Last Modified On : Mon Apr 13 22:37:03 2020
-// Update Count     : 110
+// Last Modified On : Wed Apr 15 10:51:01 2020
+// Update Count     : 119
 // 
 
@@ -88,27 +88,60 @@
 
     // Returns n aligned at the floor of align, clear bits above or equal to align, giving n % align.
-    // signed char floor2( signed char n, signed char align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // unsigned char floor2( unsigned char n, unsigned char align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // short int floor2( short int n, unsigned short int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // unsigned short int floor2( unsigned short int n, unsigned short int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // int floor2( int n, unsigned int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // unsigned int floor2( unsigned int n, unsigned int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // long int floor2( long int n, unsigned long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // unsigned long int floor2( unsigned long int n, unsigned long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-	// long long int floor2( long long int n, unsigned long long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
-    // unsigned long long int floor2( unsigned long long int n, unsigned long long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    signed char floor2( signed char n, char align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    unsigned char floor2( unsigned char n, unsigned char align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    short int floor2( short int n, short int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    unsigned short int floor2( unsigned short int n, unsigned short int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    int floor2( int n, int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    unsigned int floor2( unsigned int n, unsigned int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    long int floor2( long int n, long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    unsigned long int floor2( unsigned long int n, unsigned long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+	long long int floor2( long long int n, long long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
+    unsigned long long int floor2( unsigned long long int n, unsigned long long int align ) { /*assert( is_pow2( align ) );*/ return n & -align; }
 
-	forall( otype T | { T ?&?( T, T ); T -?( T ); } )
-	T floor2( T n, T align ) { /* assert( is_pow2( align ) ); */ return n & -align; }
+	// forall( otype T | { T ?&?( T, T ); T -?( T ); } )
+	// T floor2( T n, T align ) { /* assert( is_pow2( align ) ); */ return n & -align; }
 
-	forall( otype T | { T ?/?( T, T ); T ?*?( T, T ); } )
-	T floor( T n, T align ) { return n / align * align; }
+    signed char floor( signed char n, char align ) { return n / align * align; }
+    unsigned char floor( unsigned char n, unsigned char align ) { return n / align * align; }
+    short int floor( short int n, short int align ) { return n / align * align; }
+    unsigned short int floor( unsigned short int n, unsigned short int align ) { return n / align * align; }
+    int floor( int n, int align ) { return n / align * align; }
+    unsigned int floor( unsigned int n, unsigned int align ) { return n / align * align; }
+    long int floor( long int n, long int align ) { return n / align * align; }
+    unsigned long int floor( unsigned long int n, unsigned long int align ) { return n / align * align; }
+	long long int floor( long long int n, long long int align ) { return n / align * align; }
+    unsigned long long int floor( unsigned long long int n, unsigned long long int align ) { return n / align * align; }
+
+	// forall( otype T | { T ?/?( T, T ); T ?*?( T, T ); } )
+	// T floor( T n, T align ) { return n / align * align; }
 
     // Returns n aligned at the ceiling of align, negate, round down, negate is the same as round up.
-	forall( otype T | { T floor2( T, T ); T -?( T ); } )
-	T ceiling2( T n, T align ) { /* assert( is_pow2( align ) ); */ return -floor2( -n, align ); }
+    signed char ceiling2( signed char n, char align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    unsigned char ceiling2( unsigned char n, unsigned char align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    short int ceiling2( short int n, short int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    unsigned short int ceiling2( unsigned short int n, unsigned short int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    int ceiling2( int n, int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    unsigned int ceiling2( unsigned int n, unsigned int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    long int ceiling2( long int n, long int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    unsigned long int ceiling2( unsigned long int n, unsigned long int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+	long long int ceiling2( long long int n, long long int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
+    unsigned long long int ceiling2( unsigned long long int n, unsigned long long int align ) { /*assert( is_pow2( align ) );*/ return -floor2( -n, align ); }
 
-	forall( otype T | { void ?{}( T &, one_t ); T ?+?( T, T ); T ?-?( T, T ); T ?/?( T, T ); } )
-	T ceiling( T n, T align ) { return (n + (align - (T){1})) / align; }
+	// forall( otype T | { T floor2( T, T ); T -?( T ); } )
+	// T ceiling2( T n, T align ) { /* assert( is_pow2( align ) ); */ return -floor2( -n, align ); }
+
+	signed char ceiling( signed char n, char align ) { return (n + (align - 1)) / align; }
+    unsigned char ceiling( unsigned char n, unsigned char align ) { return (n + (align - 1)) / align; }
+    short int ceiling( short int n, short int align ) { return (n + (align - 1)) / align; }
+    unsigned short int ceiling( unsigned short int n, unsigned short int align ) { return (n + (align - 1)) / align; }
+    int ceiling( int n, int align ) { return (n + (align - 1)) / align; }
+    unsigned int ceiling( unsigned int n, unsigned int align ) { return (n + (align - 1)) / align; }
+    long int ceiling( long int n, long int align ) { return (n + (align - 1)) / align; }
+    unsigned long int ceiling( unsigned long int n, unsigned long int align ) { return (n + (align - 1)) / align; }
+	long long int ceiling( long long int n, long long int align ) { return (n + (align - 1)) / align; }
+    unsigned long long int ceiling( unsigned long long int n, unsigned long long int align ) { return (n + (align - 1)) / align; }
+
+	// forall( otype T | { void ?{}( T &, one_t ); T ?+?( T, T ); T ?-?( T, T ); T ?/?( T, T ); } )
+	// T ceiling( T n, T align ) { return (n + (align - (T){1})) / align; }
 } // distribution
 
